(library (idents)
  (export
   make-ident ident? ident-name ident-symbol-name
   ident-number ident-number-set!
   ident-assigned ident-assigned-set!
   ident-locations ident-locations-set!
   ident-asts ident-asts-set!
   ident-preceding-ref ident-preceding-ref-set! ident-preceding-ref-delete!
   ident-binding-node ident-binding-node-set!
   ident=?
   ident<?
   ident>?
   )
  (import (rnrs) (records-io))

(define-record-type ident 
  (fields name symbol-name
          (mutable assigned) ;; bool
          (mutable number) ;; int
          (mutable asts) ;; list[ast(ref|set)]
          (mutable locations) ;; list[int]
          (mutable preceding-ref) ;; up-ref or down-ref
          (mutable binding-node) ;; node[type]
          )
  (nongenerative)
  (protocol
   (lambda (make)
     (lambda (name symbol-name assigned)
       (make name symbol-name assigned -1 '() '() #f #f)))))

(define (ident=? x y) (= (ident-number x) (ident-number y)))
(define (ident<? x y) (< (ident-number x) (ident-number y)))
(define (ident>? x y) (> (ident-number x) (ident-number y)))
(define (ident-preceding-ref-delete! ident)
  (ident-preceding-ref-set! ident #f))

(record-writer (record-type-descriptor ident)
  (lambda (r p wr)
    (display "#[ident " p)
    (display (ident-symbol-name r) p)
    (display " " p)
    (write (ident-assigned r) p)
    (display "]" p)))

)
