(library (transform-let)
  (export transform-let)
  (import (rnrs) (tprogram))

;; Trex -> Trex
(define (transform-let trex)
  (define rec transform-let)

  (or (Trex-case trex
        [(App src-app fun actuals)
         (Trex-case fun
           [(CaseLambda src-lambda clauses)
            (cond
             [(= 1 (length clauses))
              (Trex-CaseLambdaClause-case (car clauses)
                [(CaseLambdaClause formals body)
                 (cond
                  [(and (list? formals) (= (length formals) (length actuals)))
                   (Letrec src-app formals (map rec actuals) (rec body))]
                  [else #f])]
                [else #f])]
             [else #f])]
           [else #f])]
        [else #f])

      (Trex-case trex
        [(Ref src id) trex]
        [(Quote src obj) trex]
        [(Primref src safe name) trex]
        [(Set src id body) (Set src id (rec body))]
        [(App src fun actuals) (App src (rec fun) (map rec actuals))]
        [(If src test thn els) (If src (rec test) (rec thn) (rec els))]
        [(CaseLambda src clauses)
         (let ([f (lambda (clause)
                    (Trex-CaseLambdaClause-case clause
                      [(CaseLambdaClause formals body)
                       (CaseLambdaClause formals (rec body))]))])
           (CaseLambda src (map f clauses)))]
        [(Seq src e1 e2) (Seq src (rec e1) (rec e2))]
        [(Letrec src lhs rhs body) (Letrec src lhs (map rec rhs) (rec body))])))

)
