(library (type-recovery)
  (export run-type-recovery)
  (import (rnrs) (ast) (ast-flow-graphs)
          (ast-bubbles) (ast-unparse) (env-flow-graphs) (value-flow-graphs)
          (flow-graphs) (transform-let) (types) (prefix (tprogram) Trex:))

(define (escape-top-level-lambda x)
   (Trex:App #f (Trex:Primref #f #f 'escape) (list x)))

;; Trex -> Trex
(define (run-type-recovery trex)
  (let ([flow-graph (make-flow-graph)])
    (with-AST-flow-graph flow-graph
      (let ([ast (Trex->AST (escape-top-level-lambda (transform-let trex)))])
        (make-AST-bubbles ast)

        ;; create the flow graph nodes
        (make-env-flow-graph ast)
        (make-value-flow-graph ast)
        (env-flow-graph-force! ast)

        ;; run the flow graph
        (let loop ()
          (unless (flow-graph-stable? flow-graph)
            (flow-graph-step! flow-graph)
            (loop)))

        (AST->Trex ast)))))

)
